/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*-
 *
 * tracker-tag-cloud.h: Tracker tag cloud widget
 *
 * Copyright (C) 2007 Marko Anastasov <marko@marko.anastasov.name>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 */

#ifndef __TRACKER_TAG_CLOUD_H__
#define __TRACKER_TAG_CLOUD_H__

#include <gtk/gtk.h>
#include "tracker-tag-cloud-model.h"

G_BEGIN_DECLS

#define TRACKER_TYPE_TAG_CLOUD            (tracker_tag_cloud_get_type ())
#define TRACKER_TAG_CLOUD(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), TRACKER_TYPE_TAG_CLOUD, TrackerTagCloud))
#define TRACKER_TAG_CLOUD_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  TRACKER_TYPE_TAG_CLOUD, TrackerTagCloudClass))
#define TRACKER_IS_TAG_CLOUD(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TRACKER_TYPE_TAG_CLOUD))
#define TRACKER_IS_TAG_CLOUD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  TRACKER_TYPE_TAG_CLOUD))
#define TRACKER_TAG_CLOUD_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  TRACKER_TYPE_TAG_CLOUD, TrackerTagCloudClass))

typedef struct _TrackerTagCloud TrackerTagCloud;
typedef struct _TrackerTagCloudClass TrackerTagCloudClass;
typedef struct _TrackerTagCloudPrivate TrackerTagCloudPrivate;

struct _TrackerTagCloud
{
	GtkScrolledWindow parent;

	/*< public >*/
	GtkWidget *canvas;

	/*< private >*/
	TrackerTagCloudPrivate *priv;

	/* Padding for future expansion */
	void (*_tracker_tag_cloud_reserved1) (void);
	void (*_tracker_tag_cloud_reserved2) (void);
	void (*_tracker_tag_cloud_reserved3) (void);
	void (*_tracker_tag_cloud_reserved4) (void);
};

struct _TrackerTagCloudClass
{
	GtkScrolledWindowClass parent_class;

	/* Signals */
	void (* clicked) (TrackerTagCloud *cloud, gchar *tag);

	/* Padding for future expansion */
	void (*_tracker_tag_cloud_reserved1) (void);
	void (*_tracker_tag_cloud_reserved2) (void);
	void (*_tracker_tag_cloud_reserved3) (void);
	void (*_tracker_tag_cloud_reserved4) (void);
	void (*_tracker_tag_cloud_reserved5) (void);
	void (*_tracker_tag_cloud_reserved6) (void);
	void (*_tracker_tag_cloud_reserved7) (void);
};

GtkWidget * tracker_tag_cloud_new            (void);

GtkWidget * tracker_tag_cloud_new_with_model (TrackerTagCloudModel *model);

void        tracker_tag_cloud_set_model      (TrackerTagCloud *cloud,
					      TrackerTagCloudModel *model);

GType       tracker_tag_cloud_get_type       (void);

G_END_DECLS

#endif /* __TRACKER_TAG_CLOUD_H__ */
